<?php

declare(strict_types=1);

namespace App\Entity\Database\Users;

use App\Repository\Users\AddressRepository;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\OneToOne;
use Doctrine\ORM\Mapping\Table;

#[Entity(repositoryClass: AddressRepository::class)]
#[Table(name: "addresses")]
class Address
{
    public function __construct(
        #[Id,
    Column,
    GeneratedValue(strategy: "SEQUENCE")]
        public ?int $id,
        #[OneToOne(targetEntity: User::class, mappedBy: 'address')]
        public ?User $user,
        #[Column(type: "text")]
        public string $street,
        #[Column(type: "text")]
        public string $suite,
        #[Column(type: "text")]
        public string $city,
        #[Column(type: "text")]
        public string $zipcode,
        #[Column]
        public float $lat,
        #[Column]
        public float $lng,
    ) {
    }
}
