<?php

declare(strict_types=1);

namespace App\Service\Remote;

use App\Entity\Remote\Brilo\Posts\Post;
use App\Entity\Remote\Brilo\Users\User;
use Psr\Log\LoggerInterface;
use Symfony\Component\Serializer\SerializerInterface;
use Symfony\Contracts\HttpClient\HttpClientInterface;

class BriloApiPosts
{
    use BriloApiFetchTrait;

    public function __construct(
        protected readonly HttpClientInterface $httpClient,
        protected readonly LoggerInterface $logger,
        protected readonly SerializerInterface $serializer,
        protected readonly string $url,
        protected readonly int $retryCount = 3,
        protected readonly int $sleepTimeS = 1,
    ) {
    }

    /**
     * Fetch all posts from Brilo API and return them as an array of Post entities.
     * @return Post[]
     * @throws \Exception
     */
    public function getPosts(): array
    {
        return $this->fetchApiResponse($this->url, Post::class);
    }
}
